'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var binaryOperators = {
    '==': true,
    '!=': true,
    '===': true,
    '!==': true,
    '<': true,
    '<=': true,
    '>': true,
    '>=': true,
    '<<': true,
    '>>': true,
    '>>>': true,
    '+': true,
    '-': true,
    '*': true,
    '/': true,
    '%': true,
    '|': true,
    '^': true,
    '&': true,
    'in': true,
    'instanceof': true,
    '**': true
};

var BinaryExpression = (function (_Expression) {
    _inherits(BinaryExpression, _Expression);

    // TODO: Should respect operator precedence: putting "a + b" before " * b" without parens should raise an error.

    function BinaryExpression(childNodes) {
        _classCallCheck(this, BinaryExpression);

        _get(Object.getPrototypeOf(BinaryExpression.prototype), 'constructor', this).call(this, 'BinaryExpression', childNodes);
    }

    _createClass(BinaryExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var left = children.passExpression();
            children.skipNonCode();
            if (children.currentElement.type === 'Punctuator' || children.currentElement.type === 'Keyword') {
                children.assertToken(children.currentElement.type, binaryOperators);
            } else {
                children.assertToken('Punctuator');
            }
            var operator = children.passToken().value;
            children.skipNonCode();
            var right = children.passExpression();
            children.assertEnd();

            this._left = left;
            this._operator = operator;
            this._right = right;
        }
    }, {
        key: 'left',
        get: function get() {
            return this._left;
        }
    }, {
        key: 'right',
        get: function get() {
            return this._right;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }]);

    return BinaryExpression;
})(_Expression3['default']);

exports['default'] = BinaryExpression;
module.exports = exports['default'];