'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

// TODO: create JSXBoundaryElement?

var JSXOpeningElement = (function (_Node) {
    _inherits(JSXOpeningElement, _Node);

    function JSXOpeningElement(childNodes) {
        _classCallCheck(this, JSXOpeningElement);

        _get(Object.getPrototypeOf(JSXOpeningElement.prototype), 'constructor', this).call(this, 'JSXOpeningElement', childNodes);
    }

    _createClass(JSXOpeningElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var attributes = [];
            var selfClosing = false;

            children.passToken('Punctuator', '<');
            children.skipNonCode();
            var name = children.passOneOfNode(['JSXIdentifier', 'JSXMemberExpression', 'JSXNamespacedName']);
            children.skipNonCode();

            while (true) {
                if (children.isNode('JSXAttribute')) {
                    children.skipNonCode();
                    attributes.push(children.passNode('JSXAttribute'));
                    children.skipNonCode();
                } else if (children.isNode('JSXSpreadAttribute')) {
                    children.skipNonCode();
                    attributes.push(children.passNode('JSXSpreadAttribute'));
                    children.skipNonCode();
                } else {
                    break;
                }
            }

            if (children.isToken('Punctuator', '/')) {
                children.skipNonCode();
                children.passToken('Punctuator', '/');
                selfClosing = true;
                children.skipNonCode();
            }

            children.passToken('Punctuator', '>');
            children.assertEnd();

            this._name = name;
            this._attributes = attributes;
            this._selfClosing = selfClosing;
        }
    }, {
        key: 'name',
        get: function get() {
            return this._name;
        }
    }, {
        key: 'attributes',
        get: function get() {
            return this._attributes;
        }
    }, {
        key: 'selfClosing',
        get: function get() {
            return this._selfClosing;
        }
    }]);

    return JSXOpeningElement;
})(_Node3['default']);

exports['default'] = JSXOpeningElement;
module.exports = exports['default'];