'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$freeze = require('babel-runtime/core-js/object/freeze')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var _Traverse = require('../../Traverse');

var _Traverse2 = _interopRequireDefault(_Traverse);

var Program = (function (_Statement) {
    _inherits(Program, _Statement);

    function Program(childNodes) {
        _classCallCheck(this, Program);

        _get(Object.getPrototypeOf(Program.prototype), 'constructor', this).call(this, 'Program', childNodes);

        this._isProgram = true;
        this._traverse = new _Traverse2['default']();
        this._traverse.addElements(childNodes);
        this._eventListeners = {};
    }

    _createClass(Program, [{
        key: '_acceptPlugins',
        value: function _acceptPlugins(plugins) {
            _Object$freeze(plugins);
            this._plugins = plugins;
        }
    }, {
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            if (children.isToken('Hashbang')) {
                children.passToken('Hashbang');
            }

            children.skipNonCode();

            var body = [];
            while (children.isStatement()) {
                body.push(children.passStatement());
                children.skipNonCode();
            }

            children.passToken('EOF');
            children.assertEnd();

            this._body = body;
        }

        /**
         * Returns node list with specified type from the tree.
         *
         * @param {String} type
         * @returns {Node[]}
         */
    }, {
        key: 'selectNodesByType',
        value: function selectNodesByType(type) {
            return this._traverse.selectNodesByType(type);
        }

        /**
         * Returns tokens list with specified type from the tree.
         *
         * @param {String} type
         * @returns {Token[]}
         */
    }, {
        key: 'selectTokensByType',
        value: function selectTokensByType(type) {
            return this._traverse.selectTokensByType(type);
        }
    }, {
        key: '_addElementsToProgram',
        value: function _addElementsToProgram(elements) {
            this._traverse.addElements(elements);
            this._emit('elements-add', elements);
        }
    }, {
        key: '_removeElementsFromProgram',
        value: function _removeElementsFromProgram(elements) {
            this._traverse.removeElements(elements);
            this._emit('elements-remove', elements);
        }
    }, {
        key: 'on',
        value: function on(eventName, callback) {
            if (this._eventListeners[eventName]) {
                this._eventListeners[eventName].push(callback);
            } else {
                this._eventListeners[eventName] = [callback];
            }
        }
    }, {
        key: 'off',
        value: function off(eventName, callback) {
            if (this._eventListeners[eventName]) {
                this._eventListeners[eventName] = this._eventListeners[eventName].filter(function (handler) {
                    return callback !== handler;
                });
            }
        }
    }, {
        key: '_emit',
        value: function _emit(eventName, data) {
            var handlers = this._eventListeners[eventName];
            if (handlers) {
                for (var i = 0; i < handlers.length; i++) {
                    handlers[i](data);
                }
            }
        }
    }, {
        key: 'plugins',
        get: function get() {
            return this._plugins;
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body.concat();
        }
    }]);

    return Program;
})(_Statement3['default']);

exports['default'] = Program;
;
module.exports = exports['default'];