'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var unaryOperators = {
    '-': true,
    '+': true,
    '!': true,
    '~': true,
    'typeof': true,
    'void': true,
    'delete': true
};

var UnaryExpression = (function (_Expression) {
    _inherits(UnaryExpression, _Expression);

    // TODO: Should respect operator precedence: putting "-a" after "b" without parens should raise an error.

    function UnaryExpression(childNodes) {
        _classCallCheck(this, UnaryExpression);

        _get(Object.getPrototypeOf(UnaryExpression.prototype), 'constructor', this).call(this, 'UnaryExpression', childNodes);
    }

    _createClass(UnaryExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            if (children.currentElement.type === 'Punctuator' || children.currentElement.type === 'Keyword') {
                children.assertToken(children.currentElement.type, unaryOperators);
            } else {
                children.assertToken('Punctuator');
            }

            var operator = children.passToken().value;
            children.skipNonCode();

            var argument = children.passExpression();

            children.assertEnd();

            this._argument = argument;
            this._operator = operator;
        }
    }, {
        key: 'argument',
        get: function get() {
            return this._argument;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }, {
        key: 'prefix',
        get: function get() {
            return true;
        }
    }]);

    return UnaryExpression;
})(_Expression3['default']);

exports['default'] = UnaryExpression;
module.exports = exports['default'];