

/**
 * Plugin abstract class.
 * Every plugin should implement this interface.
 * All plugins inside cst package should extend this class.
 */
'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var BasePlugin = (function () {
  function BasePlugin() {
    _classCallCheck(this, BasePlugin);
  }

  _createClass(BasePlugin, [{
    key: 'createApiForProgram',

    /**
     * Returns plugin API.
     * Plugin's API will be accessible using `program.plugins.<pluginName>`.
     */
    value: function createApiForProgram(program) {}
  }, {
    key: 'pluginName',

    /**
     * Returns plugin name.
     * Plugin's API will be accessible using `program.plugins.<pluginName>`.
     */
    get: function get() {
      return 'basePlugin';
    }
  }]);

  return BasePlugin;
})();

exports['default'] = BasePlugin;
module.exports = exports['default'];