'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Set = require('babel-runtime/core-js/set')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _utilsToArray = require('../../utils/toArray');

var _utilsToArray2 = _interopRequireDefault(_utilsToArray);

var Variable = (function () {
    function Variable(_ref) {
        var name = _ref.name;
        var type = _ref.type;
        var scope = _ref.scope;
        return (function () {
            _classCallCheck(this, Variable);

            this._name = name;
            this._type = type;
            this._scope = scope;
            this._definitions = new _Set();
            this._references = new _Set();
        }).apply(this, arguments);
    }

    _createClass(Variable, [{
        key: '_addDefinition',
        value: function _addDefinition(definition) {
            definition._variable = this;
            this._definitions.add(definition);
        }
    }, {
        key: '_addReference',
        value: function _addReference(reference) {
            reference._variable = this;
            this._references.add(reference);
        }
    }, {
        key: '_removeDefinition',
        value: function _removeDefinition(definition) {
            this._definitions['delete'](definition);
        }
    }, {
        key: '_removeReference',
        value: function _removeReference(reference) {
            this._references['delete'](reference);
        }
    }, {
        key: '_transferReferences',
        value: function _transferReferences(variable) {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = _getIterator(this._references), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var reference = _step.value;

                    if (!reference._type) {
                        this._references['delete'](reference);
                        variable._references.add(reference);
                        reference._variable = variable;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator['return']) {
                        _iterator['return']();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: 'name',
        get: function get() {
            return this._name;
        }
    }, {
        key: 'type',
        get: function get() {
            return this._type;
        }
    }, {
        key: 'definitions',
        get: function get() {
            return (0, _utilsToArray2['default'])(this._definitions);
        }
    }, {
        key: 'references',
        get: function get() {
            return (0, _utilsToArray2['default'])(this._references);
        }
    }]);

    return Variable;
})();

exports['default'] = Variable;
module.exports = exports['default'];